# 
# TAOF, the general purpose TCP fuzzer.
# Copyright (C) 2006 Rodrigo Marcos
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
# 

import xml.dom.minidom # for xml input/output
import socket
import timeoutsocket
#from urllib2 import urlopen
#import asyncore
import sys
import os # for folder creation
from struct import pack
import time #for folder creation and sleep


from twisted.internet import gtk2reactor
gtk2reactor.install()

from twisted.protocols import portforward

import gtk

overflowstrings = ["A" * 33, "A" * 128, "A" * 240, "A" * 255, "A" * 256, "A" * 257, "A" * 420, "A" * 511, "A" * 512, "A" * 1023, "A" * 1024, "A" * 2047, "A" * 2048, "A" * 4096, "A" * 4097, "A" * 5000, "A" * 10000, "A" * 20000, "A" * 32762, "A" * 32763, "A" * 32764, "A" * 32765, "A" * 32766, "A" * 32767, "A" * 32768, "A" * 65534, "A" * 65535, "A" * 65536]
formatstrings   = ["%s" * 4, "%s" * 8, "%s" * 15, "%s" * 30, "%x" * 1024, "%n" * 1025 , "%s" * 2048, "%s%n%x%d" * 5000, "%s" * 30000, "%s" * 40000, "%.1024d", "%.2048d", "%.4096d", "%.8200d", "%99999999999s", "%99999999999d", "%99999999999x", "%99999999999n", "%99999999999s" * 1000, "%99999999999d" * 1000, "%99999999999x" * 1000, "%99999999999n" * 1000, "%08x" * 100, "%%20s" * 1000,"%%20x" * 1000,"%%20n" * 1000,"%%20d" * 1000, "%#0123456x%08x%x%s%p%n%d%o%u%c%h%l%q%j%z%Z%t%i%e%g%f%a%C%S%08x%%#0123456x%%x%%s%%p%%n%%d%%o%%u%%c%%h%%l%%q%%j%%z%%Z%%t%%i%%e%%g%%f%%a%%C%%S%%08x"]
integerstrings  = [-1, 0, 1, 127, 128, 255, 256, 32767, 32768, 65535, 65536, 2097151, 2097152, 4194304, 8388608, 16777216, 33554432, 67108864, 134217728, 268435456, 536870912, 1073741823, 1073741824, 2147483647, 2147483648, 4294967295]

integerstrings_little_endian = []
for i in integerstrings:
	integerstrings_little_endian.append(pack('<I',i))
integerstrings_big_endian = []
for i in integerstrings:
	integerstrings_big_endian.append(pack('>I',i))


####################################
####################################

def server_dataReceived(self, data):
	#print 'server recieved data:', data
	context["REQUEST_COUNTER"] += 1	
	context["logger"].log_request(context["REQUEST_COUNTER"], data)				#log the actual raw request

	context["xmllog"].add_request(context["xmldoc"], context["xmlconv"], str(context["REQUEST_COUNTER"])) 	#log into xml file
	
	portforward.Proxy.dataReceived(self, data)

portforward.ProxyServer.dataReceived = server_dataReceived

def client_dataReceived(self, data):
	#print 'client received data:', data
	#context["logger"].log_response(context["REQUEST_COUNTER"], data)
	portforward.Proxy.dataReceived(self, data)

portforward.ProxyClient.dataReceived = client_dataReceived


####################################
####################################
class xmlfuzz:

	def __init__(self):
		self.file = "fuzz.xml"

	def create_document(self,localhost, localport, desthost, destport):
		doc=xml.dom.minidom.Document()
		conversation_element = doc.createElementNS("", "conversation")
		conversation_element.setAttributeNS("","local_host", localhost)
		conversation_element.setAttributeNS("","local_port", localport)
		conversation_element.setAttributeNS("","dest_host", desthost)
		conversation_element.setAttributeNS("","dest_port", destport)
		conversation_element.setAttributeNS("","time",time.strftime("%H:%M:%S"))
		doc.appendChild(conversation_element)
		return doc, conversation_element
	
	def get_document(self, name="fuzz.xml"):
		doc = xml.dom.minidom.parse(name)
		return doc,  doc.getElementsByTagName("conversation")
	
	def get_network_info(self, doc):
		conversation_element = doc.getElementsByTagName("conversation")
		return conversation_element[0].attributes["local_host"].value, conversation_element[0].attributes["local_port"].value,conversation_element[0].attributes["dest_host"].value, conversation_element[0].attributes["dest_port"].value
		
	def add_request(self, doc, conversation_element, request_ID):
		request_element = doc.createElementNS("", "request")
		request_element.setAttributeNS("","ID",str(request_ID))
		request_element.setAttributeNS("","time",time.strftime("%H:%M:%S"))
		request_element.setAttributeNS("","as_is","0")
		conversation_element.appendChild(request_element)
		return request_element
	
#	def set_request_attributes(self, request_element, request_ignore, request_fuzz):
#		request_element.setAttributeNS("","ignore",str(request_ignore))
#		request_element.setAttributeNS("","fuzzing",str(request_fuzz))
	
	def add_as_is(self, doc, request_element):
		request_element.setAttributeNS("", "as_is", "1")
		return request_element
		
	def del_as_is(self, doc, request_element):
		request_element.setAttributeNS("", "as_is", "0")
		return request_element
		
	def add_fuzz(self, doc, request_element, fuzz_from, fuzz_to, fuzz_bo, fuzz_fs, fuzz_obo, fuzz_dict, fuzz_len, fuzz_lfrom, fuzz_lto, fuzz_lvalue, fuzz_lformat):
		fuzz_element = doc.createElementNS("", "fuzz")
#		fuzz_element.setAttributeNS("", "ID", str(fuzz_ID))
		fuzz_element.setAttributeNS("", "from", str(fuzz_from))
		fuzz_element.setAttributeNS("", "to", str(fuzz_to))
		fuzz_element.setAttributeNS("", "bo", str(fuzz_bo))
		fuzz_element.setAttributeNS("", "fs", str(fuzz_fs))
		fuzz_element.setAttributeNS("", "obo", str(fuzz_obo))
		fuzz_element.setAttributeNS("", "dict", str(fuzz_dict))
		fuzz_element.setAttributeNS("", "checklen", str(fuzz_len))
		fuzz_element.setAttributeNS("", "lfrom", str(fuzz_lfrom))
		fuzz_element.setAttributeNS("", "lto", str(fuzz_lto))
		fuzz_element.setAttributeNS("", "lvalue", str(fuzz_lvalue))
		fuzz_element.setAttributeNS("", "lformat", str(fuzz_lformat))
		request_element.appendChild(fuzz_element)
		return fuzz_element

	# Deleted a fuzzing point of a given request
	def del_fuzz(self, doc, request_element, fuzzID):
		
		fuzz_elements = request_element.getElementsByTagName("fuzz")
		request_element.removeChild(fuzz_elements[fuzzID])
	
	def write_to_screen(self, doc):
		print doc.toxml()

	def write_to_file(self, doc):
		file_object = open(self.file, "w")
		doc.writexml(file_object)
		file_object.close()

	def get_requests(self, doc):
		myrequests = doc.getElementsByTagName('request')
		return myrequests

	def get_request(self, doc, id):
		myrequests = doc.getElementsByTagName('request')
		try:
			return myrequests[id]
		except:
			return False
			
	def get_number_requests(self, doc):
		myrequests = doc.getElementsByTagName('request')
		return len(myrequests)
	
	def ignore_request(self, doc, id):
		myrequests = doc.getElementsByTagName('request')
		return myrequests[id].attributes["ignore"].value
	
	def fuzz_bo(self, doc, idrequest, idfuzz):
		myrequests = doc.getElementsByTagName('request')
		myfuzz = myrequests[idrequest].getElementsByTagName("fuzz")
		return myfuzz[idfuzz].attributes["bo"].value
	
	def fuzz_fs(self, doc, idrequest, idfuzz):
		myrequests = doc.getElementsByTagName('request')
		myfuzz = myrequests[idrequest].getElementsByTagName("fuzz")
		return myfuzz[idfuzz].attributes["fs"].value

	def fuzz_int(self, doc, idrequest, idfuzz):
		myrequests = doc.getElementsByTagName('request')
		myfuzz = myrequests[idrequest].getElementsByTagName("fuzz")
		return myfuzz[idfuzz].attributes["obo"].value
	
	def fuzz_dict(self, doc, idrequest, idfuzz):
		myrequests = doc.getElementsByTagName('request')
		myfuzz = myrequests[idrequest].getElementsByTagName("fuzz")
		return myfuzz[idfuzz].attributes["dict"].value

	# Returns the "to" and "from " of a fuzzing point in a request	
	def get_from_to(self, doc, idrequest, idfuzz):
		myrequests = doc.getElementsByTagName('request')
		myfuzz = myrequests[idrequest].getElementsByTagName("fuzz")
		return myfuzz[idfuzz].attributes["from"].value, myfuzz[idfuzz].attributes["to"].value


	# Returns all the values needed for the variable lenght field	
	def get_len(self, doc, idrequest, idfuzz):
		myrequests = doc.getElementsByTagName('request')
		myfuzz = myrequests[idrequest].getElementsByTagName("fuzz")
		return myfuzz[idfuzz].attributes["checklen"].value, myfuzz[idfuzz].attributes["lfrom"].value, myfuzz[idfuzz].attributes["lto"].value, myfuzz[idfuzz].attributes["lvalue"].value, myfuzz[idfuzz].attributes["lformat"].value

	
	# Returns the number of fuzzing points of a request (id)
	def get_number_fuzz(self, doc, id):
		myrequests = doc.getElementsByTagName('request')
		return len (myrequests[id].getElementsByTagName("fuzz"))

	# Returns an array with the fuzzing points of a request (id)
	def get_fuzzs(self, doc, id): 
		myrequests = doc.getElementsByTagName('request')
		return myrequests[id].getElementsByTagName("fuzz")
		
#############################################################################
#
# Fuzzer class 
#
#############################################################################

class fuzzer:
	

	def send_as_is(self):
	#This function sends "as_is" requests
		for requestid in range(0, context["xmllog"].get_number_requests(context["xmldoc"])):
			myrequest = context["xmllog"].get_request(context["xmldoc"],requestid)
			if myrequest.attributes["as_is"].value == "1":
				try:
					current_request = context["logger"].read_request(requestid+1)
					self.remoteserver.send(current_request)
					self.recv(context["RECV_BUFFER_SIZE"])
				except:
#					print str(sys.exc_info()[0])
					return "0"
		return "1"					
	


	def fuzz_loop(self, signatures, first_part, last_part, isnumber, checklen, lvalue, middle_part, len_position, lformat):
#TO DO non dictionary attacks:
# Learn the result of a bad request and compare the result to it instead of dumping all the results on the debugging file
# Threading

		for sg in signatures:
			#time.sleep(context["wait"]) # Wait for each request
			if context["stopfuzzing"]!=0: # The user decided to stop fuzzing
				break
			while gtk.events_pending():	# Run pending events
				gtk.main_iteration_do(False)
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),'*')#Adds a '*' on the fuzzing dialog

			if not isnumber:
				sg=sg.strip()	#Removing the new line if this is a dictionay attack, otherwise... there shouldn't be a newline

			try:
				if checklen=='1' and not isnumber:
					injectedlen = lvalue + len(sg)
					if lformat == '1': # ASCII
						injectedlen = str(injectedlen)
					elif lformat == '2': # Little endian
						injectedlen = pack('<l',injectedlen)
					else: # Big endian
						injectedlen = pack('>l',injectedlen)

					if len_position == 0: # PREPEND value
						if isnumber:
							fuzzed_request = first_part + injectedlen + middle_part + str(sg) + last_part
						else:						
							fuzzed_request = first_part + injectedlen + middle_part + sg + last_part
					else:			# POSTPEND value
						if isnumber:
							fuzzed_request = first_part + str(sg) + middle_part + injectedlen + last_part
						else:						
							fuzzed_request = first_part + sg + middle_part + injectedlen + last_part

				else:
					if isnumber:
						fuzzed_request = first_part + str(sg) + last_part
					else:
						fuzzed_request = first_part + sg + last_part

				if context["debug"]:
					if isnumber:
						debugstring = "\n*************************<REQUEST>***********************\n" 
					else:
						debugstring = "\n*************************<REQUEST>*********************** - " + str(len(sg)) + " characters\n" 
					self.file_object.write(debugstring)
					self.file_object.write(fuzzed_request)
					self.file_object.write("\n*************************<REQUEST/>***********************\n")

				self.remoteserver.send(fuzzed_request) # Send...
				results = self.remoteserver.recv(context["RECV_BUFFER_SIZE"]) # and receive...
				
				if results=="": # This usually means that the remote server closed the connection
				#Although we run the risk of sending things twice, otherwise we might skip some vulnerabilities
					res = self.reconnect() # Taof first try to reconnect and repeat the request again
					#Let's handle the reconnection.
					if res=='1': # Success reconnecting
						self.remoteserver.send(fuzzed_request)
						results = self.remoteserver.recv(context["RECV_BUFFER_SIZE"])
						if context["debug"]:
							self.file_object.write("\n+++++++++++++++++++++++++<RESPONSE>+++++++++++++++++++++++++\n")
							self.file_object.write(results)															
							self.file_object.write("\n+++++++++++++++++++++++++<RESPONSE/>+++++++++++++++++++++++++\n")
					elif res=='-1': # This might be good (connection issue, the service might have died)
						if context["debug"]:
							if isnumber:
								debugstring = "\n*** Check this out carefully. This request killed the service.\n" 
							else:
								debugstring = "\n*** Check this out carefully. This request killed the service. Request - " + str(len(sg)) + " characters\n" 
							self.file_object.write(debugstring)
							self.file_object.write("\n*************************<BUFFER>***********************\n")
							self.file_object.write(fuzzed_request)
							self.file_object.write("\n*************************<BUFFER/>***********************\n")
							self.file_object.write("\n[*] I have to give up. I can not connect to the server" )
						context["stopfuzzing"]=2
				else: # everything went ok
					if context["debug"]:
						self.file_object.write("\n+++++++++++++++++++++++++<RESPONSE>+++++++++++++++++++++++++\n")
						self.file_object.write(results)															
						self.file_object.write("\n+++++++++++++++++++++++++<RESPONSE/>+++++++++++++++++++++++++\n")								
			except socket.error, msg:
				if context["debug"]:
					self.file_object.write("\n----------------------------<SOCKET EXCEPTION>-------------------------\n")
					logtemp = "Socket.error: " + str(msg)
					self.file_object.write(logtemp)		
					self.file_object.write("\n----------------------------<SOCKET EXCEPTION/>-------------------------\n")
				res = self.reconnect()
				if res=='-1': # This might be good (connection issue, the service might have died)
					if context["debug"]:
						if isnumber:
							debugstring = "\n*** Check this out carefully. This request killed the service.\n" 
						else:
							debugstring = "\n*** Check this out carefully. This request killed the service. Request - " + str(len(sg)) + " characters\n" 
						self.file_object.write(debugstring)
						self.file_object.write("\n*************************<BUFFER>***********************\n")
						self.file_object.write(fuzzed_request)
						self.file_object.write("\n*************************<BUFFER/>***********************\n")
						self.file_object.write("\n[*] I have to give up. I can not connect to the server" )
					context["stopfuzzing"]=2
				
			except:
				if context["debug"]:
					self.file_object.write("\n----------------------------<EXCEPTION>-------------------------\n")
					self.file_object.write(str(sys.exc_info()[1]) )#+ " - " + sys.exc_info()[1])
					self.file_object.write("\n----------------------------<EXCEPTION/>-------------------------\n")
				res = self.reconnect()
				if res=='-1': # This might be good (connection issue, the service might have died)
					if context["debug"]:
						if isnumber:
							debugstring = "\n*** Check this out carefully. This request killed the service.\n" 
						else:
							debugstring = "\n*** Check this out carefully. This request killed the service. Request - " + str(len(sg)) + " characters\n" 
						self.file_object.write(debugstring)
						self.file_object.write("\n*************************<BUFFER>***********************\n")
						self.file_object.write(fuzzed_request)
						self.file_object.write("\n*************************<BUFFER/>***********************\n")
						self.file_object.write("\n[*] I have to give up. I can not connect to the server" )
					context["stopfuzzing"]=2


	def reconnect(self):
#This function reconnects to the remote server. If not possible the first time it tries again.
#Returns '1' on success and '-1' if reconnection was not possible
		try:		
			self.remoteserver = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
		except:
			pass
		
		connected = 0
		for i in range(0,2):
			try:	
				self.remoteserver.connect((context["dest_host"], int(context["dest_port"])))
				connected=1

			except socket.error, desc:
				#print desc
				if desc[0]==106:
					connected=1	# Already connected
				else:
					logtemp = "\n[*] It was not possible to connect to " + context["dest_host"] + ":" + context["dest_port"] + ". It might be down. Retrying now..."
					context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
					#time.sleep(context["wait_reconnection"]) # Let's wait a little bit
			except:
				#print str(sys.exc_info()[1])
				logtemp = "\n[*] It was not possible to connect to " + context["dest_host"] + ":" + context["dest_port"] + ". It might be down. Retrying now..."
				context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
				time.sleep(context["wait_reconnection"]) # Let's wait a little bit
			if connected==1:
				break

		if connected==0: # Ooops, we could not connect to the server. The service might have died
			logtemp = "\n[*] I could not connect to the server. I might have killed the service (which is good!)."
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
			return '-1'

		result = self.send_as_is()
	#	if context["debug"]:
	#		logtemp = "Authentication result:" + result + "\n"
	#		self.file_object.write(logtemp)
		return '1'
				
	def run(self):
	# This is the main loop for fuzzing
			
		if context["debug"]:
			self.file_object = open("debugging" , "w")			
			logtemp = "Starting fuzzing session against " + context["dest_host"] + ":" + context["dest_port"]  + " - " + time.strftime("%H:%M:%S")##########################
			self.file_object.write(logtemp)

		context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
		context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),"Check 'debugging' file for further information" + '\n\n')
		#initialization

		res = self.reconnect() # it establishes the connection to the server

		if res!='1':
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),"\nCould not connect to the server.\n")			
			if context["debug"]:
				self.file_object.write("Could not connect to the server.\n")
			return "1"
		#loops though all the requests					
		for requestid in range(0, context["xmllog"].get_number_requests(context["xmldoc"])):

			if context["stopfuzzing"]!=0: # The user decided to stop fuzzing
				break
			current_request = context["logger"].read_request(requestid+1) # we read the original request
			logtemp = "Fuzzing request: " + str(requestid)
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
			logtemp = "	Number of fuzzing points: " + str(context["xmllog"].get_number_fuzz(context["xmldoc"], requestid))
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')

			if context["debug"]:
				logtemp = "Fuzzing request: " + str(requestid) + "\n"
				self.file_object.write(logtemp)
				logtemp = "	Number of fuzzing points: " + str(context["xmllog"].get_number_fuzz(context["xmldoc"],requestid)) + "\n"
				self.file_object.write(logtemp)
			
			#It goes through each of the fuzzing points on the current request
			for fuzzid in range (0, context["xmllog"].get_number_fuzz(context["xmldoc"], requestid)):
				if context["stopfuzzing"]!=0: # The user decided to stop fuzzing
					break

				ffrom, fto = context["xmllog"].get_from_to(context["xmldoc"], requestid, fuzzid)
				#it gest the boundaries of the fuzzing point

				checklen, lfrom, lto, lvalue, lformat = context["xmllog"].get_len(context["xmldoc"], requestid, fuzzid)
				#It gets all the necessary parameters for variable lenght calculations

				print "Testing fuzzing point ", fuzzid, ": (", ffrom, " - ", fto, ")"
				if context["debug"]:
					logtemp = "Testing fuzzing point " + str(fuzzid) + ": (" + ffrom + " - " + fto + ")"
					self.file_object.write(logtemp)

				ffrom = int(ffrom)
				fto = int(fto)
				

				if checklen=='1': # This means that we need to include a variable lenght with the request
					lfrom = int(lfrom)
					lto = int(lto)
					lvalue = int(lvalue)
					
					#in order to inject the length in the correct place, we calculate the location:
					if lto<=ffrom:
						# the lenght value is located BEFORE the injection point
						first_part = current_request[:lfrom]
						middle_part = current_request[lto:ffrom]
						last_part = current_request[fto:]
						len_position = 0

					else: # We trust the value entry (we shouldn't!). To do, check that "lfrom>=to"
						# the lenght value is located AFTER the injection point
						first_part = current_request[:ffrom]
						middle_part = current_request[fto:lfrom]
						last_part = current_request[lto:]
						len_position = 1

				else: # No lenght has to be included
					first_part = current_request[:ffrom]
					last_part = current_request[fto:]
					middle_part = ''
					len_position = -1				
	
				#fuzzing buffer overflows
				if context["xmllog"].fuzz_bo(context["xmldoc"], requestid, fuzzid)=='1':
					logtemp = "\n + Buffer overflows"
					context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')

					self.fuzz_loop(overflowstrings, first_part, last_part, 0, checklen, lvalue, middle_part, len_position, lformat)
				if context["stopfuzzing"]!=0: # The user decided to stop fuzzing
					break
			
				#fuzzing format strings								 
				if context["xmllog"].fuzz_fs(context["xmldoc"], requestid, fuzzid)=='1':
					logtemp = "\n + Format Strings"
					context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
					
					self.fuzz_loop(formatstrings, first_part, last_part, 0, checklen, lvalue, middle_part, len_position, lformat)
				
				if context["stopfuzzing"]!=0: # The user decided to stop fuzzing
					break
	
				#fuzzing integer strings
				if context["xmllog"].fuzz_int(context["xmldoc"], requestid, fuzzid)=='1':
					logtemp = "\n + Integer Overflows"
					context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
					 
					#Numbers in Ascii
					self.fuzz_loop(integerstrings, first_part, last_part, 1, checklen, lvalue, middle_part, len_position, lformat)
					if context["stopfuzzing"]!=0: # The user decided to stop fuzzing
						break
					#Numbers in little Endian
					self.fuzz_loop(integerstrings_little_endian, first_part, last_part, 0, checklen, lvalue, middle_part, len_position, lformat)
					if context["stopfuzzing"]!=0: # The user decided to stop fuzzing
						break
					#Numbers in big Endian
					self.fuzz_loop(integerstrings_big_endian, first_part, last_part, 0, checklen, lvalue, middle_part, len_position, lformat)

				if context["stopfuzzing"]!=0: # The user decided to stop fuzzing
					break

				if context["xmllog"].fuzz_dict(context["xmldoc"], requestid, fuzzid)=='1' and context["dictionary"]!='':
					logtemp = "\n + Dictionary Attack"
					dictionary_file = open(context["dictionary"])
					context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),logtemp + '\n')
					self.fuzz_loop(dictionary_file, first_part, last_part, 0, checklen, lvalue, middle_part, len_position, lformat)
					dictionary_file.close()
				
				if context["stopfuzzing"]!=0: # The user decided to stop fuzzing
					break
	

		if context["debug"]:
			self.file_object.close()
		if context["stopfuzzing"]==1: # The user decided to stop fuzzing
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),"\n[*] Fuzzing session finished by user.\n")
			context["stopfuzzing"]=0
		elif context["stopfuzzing"]==2:
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),"\n[*] Fuzzing session because remote server is not responding.\n")
			context["stopfuzzing"]=0
		else:
			context["fuzzinglog"].insert(context["fuzzinglog"].get_end_iter(),"\n[*] Fuzzing session finished.\n")

#############################################################################
#
# Logger
#
#############################################################################


class Log:
	

	def __init__(self, path=0):
		#self.folder = "." + time
		if path:
			self.folder = path
			try:
				os.chdir(self.folder)
			except:
				sys.stderr.write('Problem changing folder.\n')
			
		else:
			self.folder = context["TAOF_PATH"] + "fuzzing_session-" + time.strftime('%j-%H.%M.%S')
			try:
				os.mkdir(self.folder)
				os.chdir(self.folder)
			except:
				sys.stderr.write('Problem creating logging folder.\n')

	def end(self):
		os.chdir(context["TAOF_PATH"])
#		os.rmdir(".fuzzing")

	def log_request(self, ID, request):
		file_object = open(str(ID) + "req" , "wb")
		file_object.write(request)
		file_object.close()

	def log_response(self, ID, response):
		file_object = open(str(ID) + "res" , "wb")
		file_object.write(response)
		file_object.close()

	def read_request(self, ID):
		file_object = open(str(ID) + "req" , "rb")
		request = file_object.read()
		file_object.close()
		return request

	def read_response(self, ID):
		file_object = open(str(ID) + "res" , "rb")
		response = file_object.read()
		file_object.close()
		return response




####################################
####################################
class xmlsettings:

#TO DO:
# Check the physical path when reading and writing to settings.xml

	def __init__(self):
		self.file = context["TAOF_PATH"] + "settings.xml"

	def create_document(self,timeout, wait, wait_reconnection, dictionary):
		doc=xml.dom.minidom.Document()
		settings_element = doc.createElementNS("", "taof_settings")
		settings_element.setAttributeNS("","timeout", timeout)
		settings_element.setAttributeNS("","wait", wait)
		settings_element.setAttributeNS("","wait_reconnection", wait_reconnection)
		settings_element.setAttributeNS("","dictionary", dictionary)
		doc.appendChild(settings_element)
#write to file
		file_object = open(self.file, "w")
		doc.writexml(file_object)
		file_object.close()

	
	def get_document(self):
		try:
			doc = xml.dom.minidom.parse(self.file)
		except:
			#create document with default settings
			self.create_document('3','0.2','0.5','')# timeout, wait, wait_reconnection, dictionary
			doc = xml.dom.minidom.parse(self.file)
		taof_settings = doc.getElementsByTagName("taof_settings")
		return float(taof_settings[0].attributes["timeout"].value), float(taof_settings[0].attributes["wait"].value), float(taof_settings[0].attributes["wait_reconnection"].value), taof_settings[0].attributes["dictionary"].value
	
	def get_settings(self):
		context["timeout"], context["wait"], context["wait_reconnection"], context["dictionary"] = self.get_document()
 # timeout - (seconds) timeout for receiving response from server
 # wait - (seconds) waiting time between requests 
 # wait_reconnection - (seconds) waiting time between reconections 


class checkupdates:
	def checkupdate(self):
#TO DO:
# This function for some reason doesn't work and needs to be fixed. It hangs if not connected to Internet.
# The problem is that I can not timeout the DSN request. :-(
		try:
			version_file = urlopen('http://taof.sourceforge.net/version')
			if int(version_file.read())> taof_version:
				return '1'
			else:
				return '0'
		except:
			return '0'



taof_version = 0 # for versioning
context = {}

context["RECV_BUFFER_SIZE"] = 8192
context["REQUEST_COUNTER"] = 0
context["debug"] = 1
context["stopfuzzing"] = 0
if os.name=='nt':
	context["TAOF_PATH"] = os.getcwd() + '\\'
	context["TAOF_HELP_PATH"] = context["TAOF_PATH"] + 'help\\index.html'
else:
	context["TAOF_PATH"] = os.getcwd() + '/'
	context["TAOF_HELP_PATH"] = context["TAOF_PATH"] + 'help/index.html'

taof_settings = xmlsettings()
taof_settings.get_settings()

